function RakijaAddonGuild_History_OnLoad(self)
	HybridScrollFrame_CreateButtons(GuildPlayersHistoryList, "RakijaAddonPartyHistoryButtonTemplate", 0, 0, "TOPLEFT", "TOPLEFT", 0, 0, "TOP", "BOTTOM");
	GuildPlayersHistoryList.update = RakijaAddonGuild_History_Update;
	GuildPlayersHistoryListScrollBar.doNotHide = true;
end

function RakijaAddonGuild_History_Update()
	local buttons = GuildPlayersHistoryList.buttons;
	local numButtons = #buttons;
	local dungeons = RakijaDBChar.dungeons;

	local currButtonIndex = 1;

	for i=#dungeons,1,-1 do
		currButtonIndex = RakijaAddonGuild_History_AddDay(dungeons[i + HybridScrollFrame_GetOffset(GuildPlayersHistoryList)],i,currButtonIndex);
	end

	if(currButtonIndex < numButtons) then
		for k=currButtonIndex ,numButtons do
			buttons[k]:Hide();
		end
	end

	local totalHeight = currButtonIndex * (20 + 0);
	local displayedHeight = numButtons * (20 + 0);
	HybridScrollFrame_Update(GuildPlayersHistoryList, totalHeight, displayedHeight);
end

function RakijaAddonGuild_History_onClick(self,button)

end

function RakijaAddonGuild_History_AddDay(day,dayName,currButtonIndex)
	local buttons = GuildPlayersHistoryList.buttons;
	local button = buttons[currButtonIndex + HybridScrollFrame_GetOffset(GuildPlayersHistoryList)];

	button:Show();

	button.string1:Show();
	button.string1:SetText(day.date);

	button.chest1:Hide();
	button.chest2:Hide();
	button.chest3:Hide();
	
	button.string2:Hide();
	button.string3:Hide();

	button.expandButton:Show();

	button.expandButton.dayName = dayName;

	currButtonIndex = currButtonIndex + 1;

	if(day.isExpanded)then
		button.expandButton:SetText("-");
		for dungeonDisplayName,dungeon in pairs(day) do
			if(type(dungeon) == "table")then
				RakijaAddonGuild_History_AddDungeon(dungeon,dungeonDisplayName,currButtonIndex);
				currButtonIndex = currButtonIndex + 1;
			end
		end
	else
		button.expandButton:SetText("+");
	end

	return currButtonIndex;
end

function RakijaAddonGuild_History_AddDungeon(dungeon,displayName,currButtonIndex)
	local buttons = GuildPlayersHistoryList.buttons;
	local button = buttons[currButtonIndex + HybridScrollFrame_GetOffset(GuildPlayersHistoryList)];

	button:Show();
	button.dungeon = dungeon;

	button.string1:Hide();

	button.string2:SetText(dungeon.name.." +"..dungeon.resault.level);
	button.string2:Show();

	button.expandButton:Hide();

	for i=1,3 do
		local chestIcon = _G[button:GetName().."Chest"..i];
		if((dungeon.resault.keystoneUpgradeLevels > 0) and i <= dungeon.resault.keystoneUpgradeLevels)then
			chestIcon:Show();
			chestIcon:SetTexCoord(GetTexCoordsByGrid(3,6,256,256,32,32));
		else
			chestIcon:Hide();
		end
	end

	local displayTime = RakijaAddon_FormatTime(dungeon.resault.time);

	if(dungeon.resault.onTime)then
		button.string3:SetText(GREEN_FONT_COLOR_CODE..displayTime);
	else
		button.string3:SetText(RED_FONT_COLOR_CODE..displayTime);	
	end
	
	button.string3:Show();

end

function RakijaAddonGuild_History_colapseButtonClick(self,button)
	RakijaDBChar.dungeons[self.dayName].isExpanded = not RakijaDBChar.dungeons[self.dayName].isExpanded;
	RakijaAddonGuild_History_Update();
end
