
RAKIJA_ADDON_SUBFRAMES = {"RakijaGuildFrame","RakijaRaidFrame","RakijaLootFrame" , "RakijaSettingsFrame"}


local RAKIJA_LISTING_BUTTON_OFFSET = 2;
local RAKIJA_LISTING_BUTTON_HEIGHT = 20;

local RAKIJA_ADDON_INSPECT_BUTTONS =
{
	"InspectHeadSlotRakija",
	"InspectNeckSlotRakija",
	"InspectShoulderSlotRakija",
	"InspectChestSlotRakija",
	"InspectShirtSlotRakija",
	"InspectWristSlotRakija",
	"InspectHandsSlotRakija",
	"InspectWaistSlotRakija",
	"InspectLegsSlotRakija",
	"InspectFeetSlotRakija",
	"InspectRing1SlotRakija",
	"InspectRing2SlotRakija",
	"InspectTrinket1SlotRakija",
	"InspectTrinket2SlotRakija",
	"InspectMainHandSlotRakija",
	"InspectOffHandSlotRakija"
};

local RAKIJA_ADDON_RELIC_BUTTONS = 
{
	"InspectRelic1Rakija",
	"InspectRelic2Rakija",
	"InspectRelic3Rakija"
};

local RAKIJA_ADDON_PROFESSION_FRAMES = 
{
	"RakijaPrimaryProfession1",
	"RakijaPrimaryProfession2"
};

function RakijaAddon_OnShow(self)
	RakijaAddonGuild_Listing_Update();
	RakijaAddonGuild_UpdateProfessionTab(RakijaPrimaryProfession1,nil);
	RakijaAddonGuild_UpdateProfessionTab(RakijaPrimaryProfession2,nil);
end

function RakijaAddon_OnLoad(self)
	tinsert(UISpecialFrames, self:GetName());
	self:RegisterForDrag("LeftButton");
	
	PanelTemplates_SetNumTabs(self, 4);
	PanelTemplates_SetTab(self, 1);
	GuildPlayersList.selectedIndex = -1;

	-- ********************************************* RPC  ***********************************************

	RegisterAddonMessagePrefix(RAKIJA_ADDON_MESSAGE_PREFIX);
	self:RegisterEvent("CHAT_MSG_ADDON");
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("GET_ITEM_INFO_RECEIVED");
	self:RegisterEvent("ARTIFACT_OPEN");
	self:RegisterEvent("ARTIFACT_CLOSE");
	self:RegisterEvent("GUILD_ROSTER_UPDATE");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");

	--self:RegisterEvent("CHALLENGE_MODE_START");
	--self:RegisterEvent("CHALLENGE_MODE_COMPLETED");
	self:RegisterEvent("UNIT_AURA");
	self:RegisterEvent("GROUP_ROSTER_UPDATE");
	self:RegisterEvent("LOOT_OPENED");
	self:RegisterEvent("LOOT_CLOSED");

	RakijaAddon_SendAddonMessage("INIT",RAKIJA_ADDON_GLOBAL_VERSION,"GUILD");

	-- **************************************************************************************************

	SortGuildRoster("rank");
	SortGuildRoster("online");
end

function RakijaAddon_Settings_Restore()

	for k,v in pairs(RakijaAddonPrimaryCheckboxes) do
		local button = _G[v];
		local specID = button:GetID();
		local checkButton = button.checkButton;

		checkButton:SetChecked(specID == RakijaDBChar.settings.mainspec);
	end

	for k,v in pairs(RakijaAddonSecondaryCheckboxes) do
		local button = _G[v];
		local specID = button:GetID();
		local checkButton = button.checkButton;

		checkButton:SetChecked(specID == RakijaDBChar.settings.offspec);
	end

	if(RakijaDBChar.settings.map.x)then
		RakijaMiniMap:SetPoint("CENTER", Minimap, "CENTER", RakijaDBChar.settings.map.x, RakijaDBChar.settings.map.y);
	end
end

function RakijaAddon_GuildRosterUpdate(self)
	if(self:IsShown())then
		RakijaAddonGuild_Listing_Update();
	end
end

function RakijaAddon_AddonLoaded(self)
	
	RakijaDB.loaded = true;
	RakijaDBChar.loaded = true;

	GuildRoster();
	GuildShowOffline:SetChecked(not RakijaDBChar.settings.showOffline);
	RakijaAddonGuild_Listing_Update();

	RakijaDBChar.settings.version = RAKIJA_ADDON_GLOBAL_VERSION;

	RakijaAddon_Scheduler_Create();
	RakijaAddon_Scheduler_AddEvent("RakijaGarbageCollector",1,RakijaAddon_CollectGarbage,true);

	RakijaAddonGuild_History_Update();

	RakijaAddon_Settings_Restore();

	if(RakijaAddon_CMStore.isActive)then
		self:RegisterEvent("COMBAT_LOG_EVENT");
		self:RegisterEvent("SCENARIO_POI_UPDATE");
	end

	LoadAddOn("Blizzard_ArtifactUI");
	SocketInventoryItem(16);
	if(ArtifactFrame:IsShown())then
		HideUIPanel(ArtifactFrame);
	end
end

function RakijaAddon_HookArtifactUI()
	ArtifactFrame:HookScript("onShow",RakijaAddon_StoreAllRelicsInfo);
end

function RakijaAddon_GetItemInfoRecived()
	RakijaAddonGuild_UpdateInspectButtons();
end

function RakijaAddon_OnEvent(self,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10)

	if((arg1 == "CHAT_MSG_ADDON") and (arg2 == RAKIJA_ADDON_MESSAGE_PREFIX))then
		RakijaAddon_ProcessAddonMessage(arg3,arg4,arg5);

	elseif((arg1 == "ADDON_LOADED") and (arg2 == "Rakija"))then
		RakijaAddon_AddonLoaded(self);
	elseif((arg1 == "ADDON_LOADED") and (arg2 == "Blizzard_ArtifactUI"))then
		RakijaAddon_HookArtifactUI();

	elseif((arg1 == "GET_ITEM_INFO_RECEIVED"))then
		RakijaAddon_GetItemInfoRecived();
		GetItemInfo_Event(self,arg2);

	elseif((arg1 == "GUILD_ROSTER_UPDATE"))then
		RakijaAddon_GuildRosterUpdate(self);

	elseif((arg1 == "UNIT_INVENTORY_CHANGED"))then
		RakijaAddon_SetReadyForUpdate();

	elseif(arg1 == "CHALLENGE_MODE_START")then
		RakijaAddon_SetupCM(self);

	elseif(arg1 == "CHALLENGE_MODE_COMPLETED")then
		RakijaAddon_CloseCM(self);

	elseif(arg1 == "COMBAT_LOG_EVENT")then
		RakijaAddon_checkDead(arg3,arg10);

	elseif(arg1 == "SCENARIO_POI_UPDATE")then
		RakijaAddon_UpdateCMINFO();
	
	elseif((arg1 == "UNIT_AURA") or (arg1 == "GROUP_ROSTER_UPDATE"))then
		RakijaAddon_AuraUpdate(self);
	
	elseif(arg1 == "LOOT_OPENED")then
		RakijaAddon_Loot_LootOpened();

	elseif(arg1 == "LOOT_CLOSED")then
		RakijaAddon_Loot_LootClosed();
	end
end

function RakijaAddon_OnClick (self, button)
	local name = self:GetName();
	if ( name == "RakijaAddonFrameTab1" ) then
		RakijaAddon_ShowPanel("RakijaGuildFrame");
	elseif ( name == "RakijaAddonFrameTab2" ) then
		RakijaAddon_ShowPanel("RakijaRaidFrame");	
	elseif ( name == "RakijaAddonFrameTab3" ) then
		RakijaAddon_ShowPanel("RakijaLootFrame");
	elseif ( name == "RakijaAddonFrameTab4" ) then
		RakijaAddon_ShowPanel("RakijaSettingsFrame");		
	end
	PlaySound("igCharacterInfoTab");
end

function RakijaAddon_ShowPanel(frameName)
	local frame;
	for index, value in pairs(RAKIJA_ADDON_SUBFRAMES) do
		if ( value == frameName ) then
			frame = _G[value];
		else
			_G[value]:Hide();
		end	
	end
	if ( frame ) then
		frame:Show();
	end
end

function RakijaAddonGuild_Listing_ButtonShowOff_OnCecked(self)
	RakijaDBChar.settings.showOffline = not self:GetChecked();
	RakijaAddonGuild_Listing_Update();
	RakijaAddonGuild_UpdateProfessions();
end

function RakijaAddonGuild_Listing_SetStringText(buttonString, text, isOnline, class)
	buttonString:SetText(text);
	buttonString:Show();

	if ( isOnline ) then
		if ( class ) then
			local classColor = RAID_CLASS_COLORS[class];
			buttonString:SetTextColor(classColor.r, classColor.g, classColor.b);
		else
			buttonString:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		end
	else
		buttonString:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	end

end

function RakijaAddonGuild_GetSelectedMemberDetail()
	local memberInfo = {};
	local gearInfo = {};

	local memberIndex = GuildPlayersList.selectedIndex;
	local fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName, achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(memberIndex);

	memberInfo = 
	{
		fullName = fullName,
		rank = rank,
		rankIndex = rankIndex,
		level = level,
		class = class,
		zone = zone,
		note = note,
		officernote = officernote,
		online = online,
		isAway = isAway,
		classFileName = classFileName,
		achievementPoints = achievementPoints,
		achievementRank =achievementRank,
		isMobile = isMobile
	};

	return memberInfo;
end

function RakijaAddonGuild_GetAllGuildMembers(onlineOnly)
	GuildRoster();

	local members = {};
	local totalMembers, _, _ = GetNumGuildMembers();
	local fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName, achievementPoints, achievementRank, isMobile;
	local searchText = RakijaGuildFrame.searchBox:GetText();
	local match = true;
	local it = 1;

	for i=0,totalMembers do
		fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName, achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(i);

		if(searchText ~= "" and fullName)then
			match = strfind(string.lower(fullName), string.lower(searchText));
		end

		if(((not onlineOnly or isMobile) or online) and match and fullName)then
			members[it] = 
			{
				fullName = fullName,
				rank = rank,
				rankIndex = rankIndex,
				level = level,
				class = class,
				zone = zone,
				note = note,
				officernote = officernote,
				online = online,
				isAway = isAway,
				classFileName = classFileName,
				achievementPoints = achievementPoints,
				achievementRank =achievementRank,
				isMobile = isMobile
			};

			it = it + 1;
		end
	end

	return members;
end

function RakijaAddonGuild_Listing_OnLoad(self)
	HybridScrollFrame_CreateButtons(GuildPlayersList, "RakijaGuildListingButtonTemplate", 5, 0, "TOPLEFT", "TOPLEFT", 0, -RAKIJA_LISTING_BUTTON_OFFSET, "TOP", "BOTTOM");

	RequestGuildRewards();
	QueryGuildNews();
	OpenCalendar();
	GuildRoster();

	GuildPlayersList.update = RakijaAddonGuild_Listing_Update;
	GuildPlayersListScrollBar.doNotHide = true;
	RakijaAddonMainFrame = self;
end

function RakijaAddonGuild_Listing_OnClicked(self, button)
	if(button == "LeftButton")then
		GuildPlayersList.selectedIndex = self.guildPlayerIndex;
		if(self.isOnline)then
			RakijaAddon_RequestGearFromTarget(self.displayedName);
		end
	else
		GuildPlayersList.selectedIndex = -1;
	end

	RakijaAddonGuild_Listing_Update();
	RakijaAddonGuild_UpdateInspectButtons();
	RakijaAddonGuild_UpdateProfessions();
end

function RakijaAddonGuild_UpdateProfessionTab(frame,ProfData,fullName)
	if(ProfData)then
		local skillID = GetSkillIDForProf(ProfData.texture); 

		frame.missingHeader:Hide();
		frame.missingText:Hide();

		frame.skillName = ProfData.name;
		frame.spellOffset = ProfData.spelloffset;
		frame.skillLine = ProfData.skillLine;
		frame.specializationIndex = ProfData.specializationIndex;
		frame.specializationOffset = ProfData.specializationOffset;
		frame.skillID = skillID;
		frame.fullName = fullName;

		
		frame.statusBar:SetMinMaxValues(1,ProfData.maxRank);
		frame.statusBar:SetValue(ProfData.rank);
		
		local prof_title = "";
		for i=1,#PROFESSION_RANKS do
		    local value,title = PROFESSION_RANKS[i][1], PROFESSION_RANKS[i][2]; 
			if ProfData.maxRank < value then break end
			prof_title = title;
		end
		frame.rank:SetText(prof_title);
		
		frame.statusBar:Show();
		if ProfData.rank == ProfData.maxRank then
			frame.statusBar.capRight:Show();
		else
			frame.statusBar.capRight:Hide();
		end

		if frame.icon and ProfData.texture then
			SetPortraitToTexture(frame.icon, ProfData.texture);	
		end
		
		frame.professionName:SetText(ProfData.name);
		
		if ( ProfData.rankModifier > 0 ) then
			frame.statusBar.rankText:SetFormattedText(TRADESKILL_RANK_WITH_MODIFIER, ProfData.rank, ProfData.rankModifier,ProfData.maxRank);
		else
			frame.statusBar.rankText:SetFormattedText(TRADESKILL_RANK, ProfData.rank, ProfData.maxRank);
		end

	else

		frame.missingHeader:Show();
		frame.missingText:Show();
		
		if frame.icon then
			SetPortraitToTexture(frame.icon, "Interface\\Icons\\INV_Scroll_04");			
			frame.specialization:SetText("");
		end			
		frame.statusBar:Hide();
		frame.rank:SetText("");
		frame.skillID = nil;
		frame.fullName = nil;
		frame.professionName:SetText("");		
	end
end

function RakijaAddonGuild_UpdateProfessions()
	local memberIndex = GuildPlayersList.selectedIndex;
	local fullName, _, _, _, _, _, _, _, _, _, _, _, _, _ = GetGuildRosterInfo(memberIndex);
	if(RakijaDB.guildMembers[fullName])then
		RakijaAddonGuild_UpdateProfessionTab(RakijaPrimaryProfession1,RakijaDB.guildMembers[fullName].professions[1],fullName);
		RakijaAddonGuild_UpdateProfessionTab(RakijaPrimaryProfession2,RakijaDB.guildMembers[fullName].professions[2],fullName);
	else
		RakijaAddonGuild_UpdateProfessionTab(RakijaPrimaryProfession1,nil);
		RakijaAddonGuild_UpdateProfessionTab(RakijaPrimaryProfession2,nil);
	end
end

function RakijaAddonGuild_Listing_Update()
	
	local buttons = GuildPlayersList.buttons;
	local offset = HybridScrollFrame_GetOffset(GuildPlayersList);
	local numButtons = #buttons;
	local members = RakijaAddonGuild_GetAllGuildMembers(RakijaDBChar.settings.showOffline);
	local numMembers = #members;
	local displayedCount = 0;

	for i=1,numButtons do

		local index = i + offset;
		local button = buttons[i];
		local member = members[index];

		if(member)then

			displayedCount = displayedCount + 1;	

			button.guildPlayerIndex = index;
			button:Show();

			if(button.guildPlayerIndex == GuildPlayersList.selectedIndex)then
				button:LockHighlight();
			else
				button:UnlockHighlight();
			end

			local displayedName = Ambiguate(member.fullName, "guild");

			RakijaAddonGuild_Listing_SetStringText(button.string1, member.level, member.online)
			button.icon:SetTexCoord(unpack(CLASS_ICON_TCOORDS[member.classFileName]));
			RakijaAddonGuild_Listing_SetStringText(button.string2, displayedName, member.online, member.classFileName)
			RakijaAddonGuild_Listing_SetStringText(button.string3, member.rank, member.online)

			if(RakijaDB.guildMembers[member.fullName])then
				RakijaAddon_SetRoleIcon(button.iconMainSpec,RakijaDB.guildMembers[member.fullName].settings.mainspec);
				RakijaAddon_SetRoleIcon(button.iconOffSpec,RakijaDB.guildMembers[member.fullName].settings.offspec);
			else
				RakijaAddon_SetRoleIcon(button.iconMainSpec,-1);
				RakijaAddon_SetRoleIcon(button.iconOffSpec,-1);
			end

			button.isOnline = member.online;
			button.displayedName = displayedName;
			button.fullName = member.fullName;

			if(not RakijaDB.loaded)then
				RakijaAddonGuild_Listing_SetStringText(button.string4, "Load...", member.online)
			else
				if(RakijaDB.guildMembers[member.fullName] and RakijaDB.guildMembers[member.fullName].gear.iLvlequipped)then
					RakijaAddonGuild_Listing_SetStringText(
						button.string4, "Ilvl:"..RakijaAddon_GetColorisedIlvlValue(
							RakijaAddon_Round(RakijaDB.guildMembers[member.fullName].gear.iLvlequipped,1)
						), member.online
					);
				else
					RakijaAddonGuild_Listing_SetStringText(button.string4, "Ilvl: "..RED_FONT_COLOR_CODE.."N/A", member.online);
				end
			end
			
		else
			button:Hide();
		end
	end

	local totalHeight = numMembers * (RAKIJA_LISTING_BUTTON_HEIGHT + RAKIJA_LISTING_BUTTON_OFFSET);
	local displayedHeight = displayedCount * (RAKIJA_LISTING_BUTTON_HEIGHT + RAKIJA_LISTING_BUTTON_OFFSET);
	HybridScrollFrame_Update(GuildPlayersList, totalHeight, displayedHeight);
end

function RakijaAddon_SetRoleIcon(button,spec)
	if(spec == 1)then
		button:SetTexCoord(GetTexCoordsForRole("TANK"));
	elseif(spec == 2)then
		button:SetTexCoord(GetTexCoordsForRole("HEALER"));
	elseif(spec == 3)then
		button:SetTexCoord(GetTexCoordsForRole("DAMAGER"));
	else
		button:SetTexCoord(GetTexCoordsByGrid(2,3,256,256,67,67));
	end
end

function RakijaAddon_GetColorisedIlvlValue(iLevel)
	local colorIlvl = "";

	if(iLevel > 880)then
		colorIlvl = ITEM_QUALITY_COLORS[5].hex..iLevel.."|r";
	elseif(iLevel > 870)then
		colorIlvl = ITEM_QUALITY_COLORS[4].hex..iLevel.."|r";
	elseif(iLevel > 860)then
		colorIlvl = ITEM_QUALITY_COLORS[3].hex..iLevel.."|r";
	elseif(iLevel > 850)then
		colorIlvl = ITEM_QUALITY_COLORS[2].hex..iLevel.."|r";
	else
		colorIlvl = ITEM_QUALITY_COLORS[1].hex..iLevel.."|r";
	end

	return colorIlvl
end

function RakijaAddonGuild_ResetAllButtons()

	for i,slot in pairs(ItemSlots) do
		RakijaAddonGuild_ResetButton (_G[RAKIJA_ADDON_INSPECT_BUTTONS[i]]);
	end

	for i,slot in pairs(RAKIJA_ADDON_RELIC_BUTTONS) do
		RakijaAddonGuild_ResetButton (_G[RAKIJA_ADDON_RELIC_BUTTONS[i]]);
	end

end

function RakijaAddonGuild_ResetButton(button)
	button.hasItem = 0;
	button.itemLink = nil;
	button.tooltipText = nil;
	button.icon:SetTexture("");
	button.IconBorder:Hide();
end

function RakijaAddonGuild_UpdateInspectButtons()
	local memberIndex = GuildPlayersList.selectedIndex;
	if(GuildPlayersList.selectedIndex ~= -1)then
		local fullName, _, _, _, _, _, _, _, _, _, _, _, _, _ = GetGuildRosterInfo(memberIndex);

		if(RakijaDB.guildMembers[fullName])then

			for i,slot in pairs(ItemSlots) do

				local itemLink = RakijaDB.guildMembers[fullName].gear[slot];
				local button = _G[RAKIJA_ADDON_INSPECT_BUTTONS[i]];

				if(itemLink)then

					local name, _, quality, _, _, _, _, _, _, texture, _ = GetItemInfo(itemLink);

					if(name)then

						button.tooltipText = name;
						button.hasItem = 1;
						button.itemLink = itemLink;
						button.icon:SetTexture(texture);
						button.IconBorder:Show();
						button.IconBorder:SetVertexColor(BAG_ITEM_QUALITY_COLORS[quality].r, BAG_ITEM_QUALITY_COLORS[quality].g, BAG_ITEM_QUALITY_COLORS[quality].b);

					end

				else
					RakijaAddonGuild_ResetButton(button);
				end
			end

			for i=1,3 do

				local relicButton = _G[RAKIJA_ADDON_RELIC_BUTTONS[i]];

				if(i > RakijaDB.guildMembers[fullName].relicData.numRelicsSlots)then

					RakijaAddonGuild_ResetButton(relicButton);

				else

					local relic = RakijaDB.guildMembers[fullName].relicData[i];

					relicButton.tooltipText = relic.relicName;
					relicButton.hasItem = 1;
					relicButton.itemLink = relic.relicLink;
					relicButton.icon:SetTexture(relic.relicIcon);

				end
			end

		else
			RakijaAddonGuild_ResetAllButtons();
		end
	else
		RakijaAddonGuild_ResetAllButtons();
	end
end

function RakijaAddon_Setting_CPU_onLoad(self)
	self.value = GetCVarBool("scriptProfile");
	RakijaAddon_Setting_CPU_setColor(self);
end

function RakijaAddon_Setting_CPU_setColor(self)
	if(self.value)then
		self:SetText("CPU - ON");
	else
		self:SetText("CPU - OFF");
	end
end

function RakijaAddon_Guild_Search_OnSearchTextChanged(self)
	SearchBoxTemplate_OnTextChanged(self);
	RakijaAddonGuild_Listing_Update();
end
